without type_check
without warning

include graphics.e

constant mx = 160
constant my = 100
constant max_depth = 5000

sequence starfield, screen
atom speed

procedure change_pal()
  sequence a
  for x = 0 to 254 do
    a = palette(255 - x, {x / 4, x / 4, x / 4})
  end for
end procedure

procedure GenerateField()
  puts(1, "\nCreating starfield")
  starfield = {}
  for x = 1 to 500 do
    starfield = starfield & {{rand(mx * 2) - rand(mx * 2), rand(my * 2) - rand(my * 2), -rand(max_depth / 2) + 150}}
  end for
  puts(1, "[OK]\n")
  screen = {}
  for y = 0 to 199 do
    screen = screen & {repeat(0, 320)}
  end for
end procedure

procedure Clear(atom c)
  for y = 1 to 200 do
    screen[y] = repeat(c, 320)
  end for
end procedure

procedure PutScreen()
  for y = 1 to 200 do
    pixel(screen[y], {1, y})
  end for
end procedure

procedure DoCycle(atom cycl)
 puts(1, "Running a first cycle")
 for a = 0 to cycl do
  for st = 1 to length(starfield) do
      starfield[st][3] = starfield[st][3] + speed
      if (starfield[st][3] > 0) then
        starfield[st] = {rand(mx * 2) - rand(mx * 2), rand(my * 2) - rand(my * 2), -1000 - rand(mx+my)}
      end if
  end for
 end for
 puts(1, "[OK]\n")
end procedure

procedure DrawField()
  atom x, y
  Clear(0)
  x = 0
  y = 0
  for st = 1 to length(starfield) do
      if starfield[st][3] != 0 then
         x = (starfield[st][1] * 320) / (starfield[st][3]) + mx
         y = (starfield[st][2] * 320) / (starfield[st][3]) + my
         if x >= 1 and y >= 1 and x < 320 and y < 200 and starfield[st][3] > -max_depth / 2 then
            screen[y][x] = -(starfield[st][3] / 5)
         end if
      end if
      starfield[st][3] = starfield[st][3] + speed
      if (starfield[st][3] > 0) or (x < 0) or (y < 0) or (x > 320) or (y > 200) then
        starfield[st] = {rand(mx * 2) - rand(mx * 2), rand(my * 2) - rand(my * 2), -1000 - rand(mx+my)}
      end if
  end for
  PutScreen()
end procedure

puts(1, "Hi there! How is the world today?\n")
puts(1, "For all you out there who didn't know it, this is the 4th tutorial from Quarter\n")
puts(1, "Moon. This one is about starfields. It generates a random starfield and let\n")
puts(1, "you travel trough it. The stars color depends from the distance to the stars!")
puts(1, "\n\nIf you have any questions: QMSoft@webmail.net\n")
puts(1, "\nPress any key to continue...")
speed = 20
while get_key() = -1 do
end while
GenerateField()
DoCycle(250)
speed = 0
if graphics_mode(19) then
   abort(1)
end if
change_pal()
while get_key() = -1 do
  DrawField()
  if speed < 20 then speed = speed + 0.5 end if
end while
while speed > 0 do
  DrawField()
  speed = speed - 0.5
end while
speed = time()
while time() < speed + 0.5 do
end while
if graphics_mode(3) then
end if
