without type_check
without warning

include graphics.e

constant mx = 160
constant my = 100
constant max_explo = 2
constant max_depth = 500
constant explo_sp = 1.2
constant precesion = 0.6 --increase when you have a slower computer than PII 400MhZ
constant c_fade = 1.8    -- > no less then 0.6

sequence explosions, screen
--explosions = {{x, y, z, mx, my, mz, exp, {{sx, sy, sz, mx, my, mz, c}, {sx, sy, sz, mx, my, mz, c}, ...}, ...}
--  explosion x <    > explosion z   
--                  > explosion y      > relative coordinates + movements and color of particles

function sqr(atom i)
  return(i*i)
end function

procedure change_pal()
sequence a
atom m
for x = 0 to 255 do
    m = x * x / 200
    if m > 63 then m = 63 end if
    a = palette(x, {m, x / 4, 0})
end for
end procedure

procedure AddExplosion(atom q)
  sequence explo
  atom x, y, z, rx, ry, rz, r, rr
  x = rand(160) - rand(160)
  y = rand(100) - rand(100)
  z = -rand(max_depth)
  explo = {}
  explo = {{x, y, z, rand(4) - rand(4), rand(4) - rand(4), rand(4) - rand(4)}, {}}
--here 's a great formula, and i have my a friend to thank for it
--Thanxs, DJonkey Johan
  r = -q
  while r < q do
      ry = sqrt(sqr(q)-sqr(r))  -- someone might remember this one as the circle formula
      rr = -ry
      while rr < ry do
        rz = sqrt(sqr(ry)-sqr(rr))
        explo[2] = explo[2] & {{r, rz, rr, {r, rz, rr, 255}}}
        explo[2] = explo[2] & {{r,-rz, rr, {r,-rz, rr, 255}}}
        rr = rr + precesion - ((9 - q) / 20)
      end while
      explo[2] = explo[2] & {{r, ry, 0, {r, ry, 0, 255}}}
      explo[2] = explo[2] & {{r,-ry, 0, {r,-ry, 0, 255}}}
      explo[2] = explo[2] & {{r, 0, ry, {r * 2, 0, ry * 2, 255}}}
      explo[2] = explo[2] & {{r, 0, -ry, {r * 2, 0, -ry * 2, 255}}}
      r = r + precesion - ((9 - q) / 20)
  end while
  explosions = explosions & {explo}
end procedure

procedure Clear(atom c)
  for y = 1 to 200 do
    screen[y] = repeat(c, 320)
  end for
end procedure

procedure PutScreen()
  for y = 1 to 200 do
    pixel(screen[y], {1, y})
  end for
end procedure

procedure DrawBall3D()
  atom x, y, z, rx, ry, rz, sx, sy
  Clear(0)
  for qr = 1 to length(explosions) do
   x = explosions[qr][1][1]
   y = explosions[qr][1][2]
   z = explosions[qr][1][3]
   for ax = 1 to length(explosions[qr][2]) do
    rx = explosions[qr][2][ax][1]
    ry = explosions[qr][2][ax][2]
    rz = explosions[qr][2][ax][3]
    if z + rz != 0 then
       sx = ((+rx+x) * 320)/((+rz+z)) + mx
       sy = ((+ry+y) * 320)/((+rz+z)) + my
       if sx >= 1 and sy >= 1 and sx < 320 and sy < 200 then
          screen[sy][sx] = explosions[qr][2][ax][4][4]
       end if
    end if
   end for
  end for
  PutScreen()
end procedure

procedure DoExplosion()
 for qr = 1 to length(explosions) do
  for ax = 1 to length(explosions[qr][2]) do
    explosions[qr][2][ax][1] = explosions[qr][2][ax][1] + explosions[qr][2][ax][4][1]
    explosions[qr][2][ax][2] = explosions[qr][2][ax][2] + explosions[qr][2][ax][4][2]
    explosions[qr][2][ax][3] = explosions[qr][2][ax][3] + explosions[qr][2][ax][4][3]
    explosions[qr][2][ax][4][1] = explosions[qr][2][ax][4][1] / (explo_sp + (rand(9) / 10))
    explosions[qr][2][ax][4][2] = explosions[qr][2][ax][4][2] / (explo_sp + (rand(9) / 10))
    explosions[qr][2][ax][4][3] = explosions[qr][2][ax][4][3] / (explo_sp + (rand(9) / 10))
    explosions[qr][2][ax][4][4] = explosions[qr][2][ax][4][4] / c_fade
    if explosions[qr][2][ax][4][4] < 5 then
       if ax != length(explosions[qr][2]) then
         explosions[qr][2] = explosions[qr][2][1..ax-1] & explosions[qr][2][ax+1..length(explosions[qr][2])]
       else
         explosions[qr][2] = explosions[qr][2][1..ax-1]
       end if
       if ax >= length(explosions[qr][2]) then exit end if
    end if
  end for
 end for
end procedure

puts(1, "Hi ya all! This is already the 6th part of the Quarter Moon Tutorials in\nEuphoria!\n")
puts(1, "This one is about 3D - explosions. A circle is first calculated into a 3D-Ball\n")
puts(1, "and then is to explode by means of particle explosions. Every dot itself moves\n")
puts(1, "in a different position and the colors fade by means of divisions.\n")
puts(1, "Check out the source, and you'll know what i mean!\n\nAny questions or request: QMSoft@webmail.net\n\n")
puts(1, "Press a key to continue...\n")
while get_key() = -1 do
end while
screen = {}
for y = 1 to 200 do
  screen = screen & {repeat(0, 320)}
end for
explosions = {}
AddExplosion(rand(8) + 1)
if graphics_mode(19) then
   abort(1)
end if
change_pal()
while get_key() = -1 do
  DrawBall3D()
  DoExplosion()
  for x = 1 to length(explosions) do
  if length(explosions[x][2]) < 3 then
     if x < length(explosions) then
       explosions = explosions[1..x-1] & explosions[x+1..length(explosions)]
     else
       explosions = explosions[1..x-1]
     end if
     if length(explosions) < max_explo then AddExplosion(rand(8) + 1) end if
  end if
  end for
end while
if graphics_mode(3) then
end if
